/*****************************************************************************/
/*  Global definitions of Port numbers for both DT controller and DT console */
/*****************************************************************************/

#ifndef _INCLUDE_DT_PORT_NUMBERS_H_
#define _INCLUDE_DT_PORT_NUMBERS_H_

/* Definitions for Controller and console may be equal provided they are     */
/* on different nodes                                                        */


/* Port numbers for console                                                  */

#define CONSOLE_TRACE_PORT           10000
#define CONSOLE_TRACE_VAL_PORT       10001
#define CONSOLE_COMMAND_PORT         11000
#define CONSOLE_ACTIVE_PORT          11010
#define CONSOLE_OFFSET_PORT          11011
#define CONSOLE_STATUS_PORT          11020
#define CONSOLE_J2000_POS_PORT       11030
#define CONSOLE_J2000_CMD_PORT       11031
#define CONSOLE_AZEL_PORT            11041
#define CONSOLE_WEATHER_PORT         11050
#define CONSOLE_MANUAL_CMD_PORT      11051
#define CONSOLE_SAT_STAT_PORT        11060
#define CONSOLE_SAT_CMD_PORT         11061
#define CONSOLE_SUN_STAT_PORT        11070
#define CONSOLE_SUN_CMD_PORT         11071
#define CONSOLE_MOON_STAT_PORT	     11080
#define CONSOLE_MOON_CMD_PORT        11081
#define CONSOLE_DT_MODEL_STAT_PORT   11090
#define CONSOLE_DT_MODEL_CMD_PORT    11091
#define CONSOLE_LOG_PORT             11200
#define CONSOLE_LOG_PORT_IN          11201


/* Port numbers for controller                                               */

#define CTRL_TRACE_PORT              20000
#define CTRL_COMMAND_PORT            21000
#define CTRL_SHELL_PORT              11100
#define CTRL_LOG_PORT                21200

#endif /* _INCLUDE_DT_PORT_NUMBERS_H_ */
