/*
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2008
	Copyright Stichting C.A. Muller Radioastronomiestation, 2008

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef _INCLUDE_LOG_H_
#define _INCLUDE_LOG_H_

enum log_type {
	LOG_T_ERROR,
	LOG_T_WARNING,
	LOG_T_INFO,
	LOG_T_DEBUG,
};

void log_send(enum log_type type, char *fmt, ...) __attribute__ ((format (printf, 2, 3)));

int log_server_start(int port, enum log_type console_level,
    enum log_type remote_level);
void log_server_flush(void);

int log_client_start(char *host, int port, enum log_type console_level,
    enum log_type remote_level, char *name);

void log_string(char *str, size_t len, enum log_type type, char *fmt, ...);

#endif /* _INCLUDE_LOG_H_ */
