
TRACE_TARGETS += $(LIBDIR)/libtrace.la
TRACE_TARGETS += $(DIR)/trace_dump
TRACE_TARGETS += $(DIR)/trace_dumpdiff
#TRACE_TARGETS += $(DIR)/trace_fft
TRACE_TARGETS += $(DIR)/trace_list
TRACE_TARGETS += $(DIR)/trace_view

ARCHSRCS := $(DIR)/trace.c $(DIR)/trace_tcp.c
ARCHOBJS := $(ARCHSRCS:.c=.lo)


$(ARCHOBJS): CFLAGS += -Wall -O3 -fPIC
$(LIBDIR)/libtrace.la: libutils.la liblog.la
$(LIBDIR)/libtrace.la_LDFLAGS += -lutils -llog -lm
$(LIBDIR)/libtrace.la: $(ARCHOBJS)
	$(LIB_LINK)

TRACE_DUMP_SRCS := $(DIR)/trace_dump.c
TRACE_DUMP_OBJS := $(TRACE_DUMP_SRCS:.c=.o)
$(DIR)/trace_dump: libtrace.la
$(DIR)/trace_dump_LDFLAGS += -ltrace
$(DIR)/trace_dump: $(TRACE_DUMP_OBJS)

TRACE_DUMPDIFF_SRCS := $(DIR)/trace_dumpdiff.c
TRACE_DUMPDIFF_OBJS := $(TRACE_DUMPDIFF_SRCS:.c=.o)
$(DIR)/trace_dumpdiff: libtrace.la
$(DIR)/trace_dumpdiff_LDFLAGS += -ltrace
$(DIR)/trace_dumpdiff: $(TRACE_DUMPDIFF_OBJS)

TRACE_FFT_SRCS := $(DIR)/trace_fft.c
TRACE_FFT_OBJS := $(TRACE_FFT_SRCS:.c=.o)
$(DIR)/trace_fft: libtrace.la
$(DIR)/trace_fft_LDFLAGS += -ltrace -lm -lfftw3
$(DIR)/trace_fft: $(TRACE_FFT_OBJS)

TRACE_LIST_SRCS := $(DIR)/trace_list.c
TRACE_LIST_OBJS := $(TRACE_LIST_SRCS:.c=.o)
$(DIR)/trace_list: libtrace.la
$(DIR)/trace_list_LDFLAGS += -ltrace
$(DIR)/trace_list: $(TRACE_LIST_OBJS)

TRACE_VIEW_SRCS := $(DIR)/trace_view.c
TRACE_VIEW_OBJS := $(TRACE_VIEW_SRCS:.c=.o)
$(DIR)/trace_view: libtrace.la
$(DIR)/trace_view_LDFLAGS += -ltrace
$(DIR)/trace_view: $(TRACE_VIEW_OBJS)

TARGETS += $(TRACE_TARGETS)
CLEAN += $(TRACE_TARGETS) $(ARCHOBJS)
CLEAN += $(TRACE_DUMP_OBJS)
CLEAN += $(TRACE_DUMPDIFF_OBJS)
CLEAN += $(TRACE_FFT_OBJS)
CLEAN += $(TRACE_LIST_OBJS)
CLEAN += $(TRACE_VIEW_OBJS)
