/*
	dt_model.h
	Dwingeloo Telescope correction model.
	
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2011
	Copyright Stichting C.A. Muller Radioastronomiestation, 2011

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include <unistd.h>
#include <math.h>

int dt_model_init(void);

double dt_model_azimuth_delta(double az, double el);
double dt_model_azimuth_delta_rev(double az, double el);
double dt_model_elevation_delta(double az, double el);
double dt_model_elevation_delta_rev(double az, double el);

#define DT_MODEL_NAME_SIZE 256

struct dt_model_params {
	double a0;
	double c1;
	double c2;
	double e0;
	double b;
	double za;
	double aa;
	char name[DT_MODEL_NAME_SIZE];
};

int dt_model_init_server(void);
int dt_model_params_set(struct dt_model_params *params);
int dt_model_params_get(struct dt_model_params *params);
