/*
	Copyright Stichting C.A. Muller Radioastronomiestation, 2011

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <utils/tcp_connect.h>

#include <dt_port_numbers.h>
#include <utils/dt_host.h>

#define MAX_RETRIES 30
#define SLEEP_INTERVAL 10


int main(int argc, char **argv)
{
static char *tr_host;
static int tr_port;
int fd;
int retries = 0;


	if (argc != 1) {
		printf("Usage: %s\n", argv[0]);
		printf("\n");
		printf("e.g. %s\n", argv[0]);
		return 1;
	}

	tr_host = dt_host_controller();
	tr_port = CTRL_TRACE_PORT;

	fd = tcp_connect(tr_host, tr_port);

	while ((fd < 0) && (retries < MAX_RETRIES)) {
		printf("Kan CTRL_TRACE_PORT op de controller-PC niet bereiken\n");
		fflush (stdout);
		sleep (SLEEP_INTERVAL);
		fd = tcp_connect(tr_host, tr_port);
                retries++;
	}

	close(fd);

	tr_port = CTRL_COMMAND_PORT;

	fd = tcp_connect(tr_host, tr_port);

	while ((fd < 0) && (retries < MAX_RETRIES)) {
		printf("Kan CTRL_COMMAND_PORT op de controller-PC niet bereiken\n");
		fflush (stdout);
		sleep (SLEEP_INTERVAL);
		fd = tcp_connect(tr_host, tr_port);
                retries++;
	}

	close(fd);

        return ((retries >= MAX_RETRIES) ? 1 : 0);
}
