
LIBDIR:=$(DIR)/lib

$(eval $(call SUBDIR,aalib))
$(eval $(call SUBDIR,predictlib))
$(eval $(call SUBDIR,mod_websocket_dt))

CONSOLE_TARGETS := 
CONSOLE_TARGETS += $(DIR)/console_joystick
CONSOLE_TARGETS += $(DIR)/command_shell
CONSOLE_TARGETS += $(DIR)/console_moontracker
CONSOLE_TARGETS += $(DIR)/trace_proxy
CONSOLE_TARGETS += $(DIR)/trace_log
CONSOLE_TARGETS += $(DIR)/console_j2000tracker
CONSOLE_TARGETS += $(DIR)/console_j2000tracer
CONSOLE_TARGETS += $(DIR)/console_j2000_indi
CONSOLE_TARGETS += $(DIR)/log_proxy
CONSOLE_TARGETS += $(DIR)/spg_auth
CONSOLE_TARGETS += $(DIR)/console_idle
CONSOLE_TARGETS += $(DIR)/console_suntracker
CONSOLE_TARGETS += $(DIR)/console_azel
CONSOLE_TARGETS += $(DIR)/console_manual
CONSOLE_TARGETS += $(DIR)/console_weather
CONSOLE_TARGETS += $(DIR)/console_dt_model
CONSOLE_TARGETS += $(DIR)/await_controller
CONSOLE_TARGETS += $(DIR)/console_sattracker

#mod_websocket_dt/mod_websocket_dt.so

CONSOLE_SRCS :=

$(DIR)/await_controller.o: CFLAGS += -Wall -O3
$(DIR)/await_controller_LDFLAGS += -lutils
$(DIR)/await_controller: libutils.la
$(DIR)/await_controller: $(DIR)/await_controller.o
CONSOLE_SRCS += $(DIR)/await_controller.c

$(DIR)/console_joystick.o: CFLAGS += -Wall -O3
$(DIR)/console_joystick_LDFLAGS += -lcommand
$(DIR)/console_joystick: libcommand.la
$(DIR)/console_joystick: $(DIR)/console_joystick.o
CONSOLE_SRCS += $(DIR)/console_joystick.c

$(DIR)/command_shell.o: CFLAGS += -Wall -O3
$(DIR)/command_shell_LDFLAGS += -lcommand
$(DIR)/command_shell: libcommand.la
$(DIR)/command_shell: $(DIR)/command_shell.o
CONSOLE_SRCS += $(DIR)/command_shell.c

$(DIR)/console_moontracker.o: CFLAGS += -Wall -O3
$(DIR)/console_moontracker_LDFLAGS += -lcommand -lm -laa
$(DIR)/console_moontracker: libcommand.la libaa.la
$(DIR)/console_moontracker: $(DIR)/console_moontracker.o
CONSOLE_SRCS += $(DIR)/console_moontracker.c

$(DIR)/console_j2000tracker.o: CFLAGS += -Wall -O3
$(DIR)/console_j2000tracker_LDFLAGS += -lcommand -lm -lnova -ltrace
$(DIR)/console_j2000tracker: libcommand.la libtrace.la libnova.la
$(DIR)/console_j2000tracker: $(DIR)/console_j2000tracker.o
CONSOLE_SRCS += $(DIR)/console_j2000tracker.c

$(DIR)/console_j2000tracer.o: CFLAGS += -Wall -O3
$(DIR)/console_j2000tracer_LDFLAGS += -lm -lnova -lutils
$(DIR)/console_j2000tracer: libutils.la libnova.la
$(DIR)/console_j2000tracer: $(DIR)/console_j2000tracer.o
CONSOLE_SRCS += $(DIR)/console_j2000tracer.c

$(DIR)/console_j2000_indi.o: CFLAGS += -Wall -O3
$(DIR)/console_j2000_indi_LDFLAGS += -lm -lindi -lindidriver -lnova -lutils
$(DIR)/console_j2000_indi: libutils.la libnova.la
$(DIR)/console_j2000_indi: $(DIR)/console_j2000_indi.o
CONSOLE_SRCS += $(DIR)/console_j2000_indi.c

$(DIR)/console_azel.o: CFLAGS += -Wall -O3
$(DIR)/console_azel_LDFLAGS += -lcommand
$(DIR)/console_azel: libcommand.la
$(DIR)/console_azel: $(DIR)/console_azel.o
CONSOLE_SRCS += $(DIR)/console_azel.c

$(DIR)/console_manual.o: CFLAGS += -Wall -O3
$(DIR)/console_manual_LDFLAGS += -lcommand
$(DIR)/console_manual: libcommand.la
$(DIR)/console_manual: $(DIR)/console_manual.o
CONSOLE_SRCS += $(DIR)/console_manual.c

$(DIR)/console_suntracker.o: CFLAGS += -Wall -O3
$(DIR)/console_suntracker_LDFLAGS += -lcommand -lm -laa
$(DIR)/console_suntracker: libcommand.la libaa.la
$(DIR)/console_suntracker: $(DIR)/console_suntracker.o
CONSOLE_SRCS += $(DIR)/console_suntracker.c

$(DIR)/console_idle.o: CFLAGS += -Wall -O3
$(DIR)/console_idle_LDFLAGS += -lcommand
$(DIR)/console_idle: libcommand.la
$(DIR)/console_idle: $(DIR)/console_idle.o
CONSOLE_SRCS += $(DIR)/console_idle.c

$(DIR)/console_weather.o: CFLAGS += -Wall -O3
$(DIR)/console_weather_LDFLAGS += -lutils
$(DIR)/console_weather: libutils.la
$(DIR)/console_weather: $(DIR)/console_weather.o
CONSOLE_SRCS += $(DIR)/console_weather.c

$(DIR)/console_dt_model.o: CFLAGS += -Wall -O3 `pkg-config --cflags glib-2.0`
$(DIR)/console_dt_model_LDFLAGS += `pkg-config --libs glib-2.0` -llog -lutils
$(DIR)/console_dt_model: liblog.la libutils.la
$(DIR)/console_dt_model: $(DIR)/console_dt_model.o
CONSOLE_SRCS += $(DIR)/console_dt_model.c

$(DIR)/trace_proxy.o: CFLAGS += -Wall -O3
$(DIR)/trace_proxy_LDFLAGS += -ltrace
$(DIR)/trace_proxy: libtrace.la
$(DIR)/trace_proxy: $(DIR)/trace_proxy.o
CONSOLE_SRCS += $(DIR)/trace_proxy.c

$(DIR)/trace_log.o: CFLAGS += -Wall -O3
$(DIR)/trace_log_LDFLAGS += -lutils
$(DIR)/trace_log: libutils.la
$(DIR)/trace_log: $(DIR)/trace_log.o
CONSOLE_SRCS += $(DIR)/trace_log.c

$(DIR)/log_proxy.o: CFLAGS += -Wall -O3
$(DIR)/log_proxy_LDFLAGS += -llog
$(DIR)/log_proxy: liblog.la
$(DIR)/log_proxy: $(DIR)/log_proxy.o
CONSOLE_SRCS += $(DIR)/log_proxy.c

$(DIR)/spg_auth.o: CFLAGS += -Wall -O3
$(DIR)/spg_auth_LDFLAGS += -lcommand
$(DIR)/spg_auth: libcommand.la
$(DIR)/spg_auth: $(DIR)/spg_auth.o
CONSOLE_SRCS += $(DIR)/spg_auth.c

$(DIR)/console_sattracker.o: CFLAGS += -Wall -O3
$(DIR)/console_sattracker_LDFLAGS += -lcommand -lnova -lpredict
$(DIR)/console_sattracker: libcommand.la libpredict.la libnova.la
$(DIR)/console_sattracker: $(DIR)/console_sattracker.o
CONSOLE_SRCS += $(DIR)/console_sattracker.c


SRCS += $(CONSOLE_SRCS)
TARGETS += $(CONSOLE_TARGETS)
CLEAN += $(CONSOLE_TARGETS) $(CONSOLE_SRCS:.c=.o)
