/*
	Weather proxy

	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2009
	Copyright Stichting C.A. Muller Radioastronomiestation, 2009

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <stdio.h>
#include <sys/select.h>

#include <utils/tcp_listen.c>
#include <utils/weather.h>

int weather_port = 11050;

int main(int argc, char **argv)
{
	struct weather *weather;
	int fdl, fda;
	char linebuf[100];
	
	weather = weather_create("Dwingeloo");
	if (!weather)
		return -1;

	fdl = tcp_listen(weather_port, 0, 10);
	ioctl(fdl, FIONBIO, &(int){ 0 });

	while (1) {
		fda = tcp_accept(fdl);
		
		sprintf(linebuf, "%.1f C, %.0f mbar\n",
		    weather_get_temperature(weather),
		    weather_get_pressure(weather));
		printf(linebuf);
		write(fda, linebuf, strlen(linebuf));
		fflush(NULL);
		close(fda);
	}
	
	return 0;
}

