/* 
	Javascript sending azimuth & elevation coordinates

	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2008, 2014
	Copyright Stichting C.A. Muller Radioastronomiestation, 2008

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

function azel_command (url, ident)
{
	this.ident = ident;

	this.open = function (az, el)
	{
		dt_websocket_send("command " + ident + " " +
		    az + " " + el);
	}
}

var azel_loaded;
if (!azel_loaded) {
azel_loaded = true;

eval(load("utils.js"));
eval(load("dt_websocket.js"));
eval(load("dt_ui.js"));



function azel(element_name) {
	var azel_this = this;

	/* 

		Create all the UI elements

	 */

	this.window = new dt_ui_window(element_name);
	
	this.window.title_set("Azimuth & Elevation tracker");

	this.lbl_filler = new dt_ui_element(element_name + "_lbl_filler");
	this.lbl_azimuth = new dt_ui_element(element_name + "_lbl_azimuth");
	this.lbl_elevation = new dt_ui_element(element_name + "_lbl_elevation");
	this.lbl_last_setpoint = new dt_ui_element(element_name + "_lbl_last_setpoint");
	this.lbl_new_setpoint = new dt_ui_element(element_name + "_lbl_new_setpoint");

	this.val_last_azimuth = new dt_ui_value(element_name + "_val_last_azimuth");
	this.val_last_elevation = new dt_ui_value(element_name + "_val_last_elevation");
	this.txt_new_azimuth = new dt_ui_text(element_name + "_txt_new_azimuth");
	this.txt_new_elevation = new dt_ui_text(element_name + "_txt_new_elevation");

	this.pos_v1 = new dt_ui_element(element_name + "_pos_v1");
	this.pos_v2 = new dt_ui_element(element_name + "_pos_v2");
	this.pos_v3 = new dt_ui_element(element_name + "_pos_v3");
	this.position_elem = new dt_ui_element(element_name + "_position_elem");
	this.action_elem = new dt_ui_element(element_name + "_action_elem");

	this.button_track = new dt_ui_button(element_name + "_track");
	this.button_copy_pos = new dt_ui_button(element_name + "_copy_pos");
	this.button_copy_last = new dt_ui_button(element_name + "_copy_last");

	this.lbl_preset_az = new dt_ui_element(element_name + "_lbl_preset_az");
	this.button_az_n270 = new dt_ui_button(element_name + "_az_n270");
	this.button_az_n180 = new dt_ui_button(element_name + "_az_n180");
	this.button_az_n90 = new dt_ui_button(element_name + "_az_n90");
	this.button_az_0 = new dt_ui_button(element_name + "_az_0");
	this.button_az_p90 = new dt_ui_button(element_name + "_az_p90");
	this.button_az_p180 = new dt_ui_button(element_name + "_az_p180");
	this.button_az_p270 = new dt_ui_button(element_name + "_az_p270");

	this.preset_az = new dt_ui_element(element_name + "_preset_az");

	this.lbl_preset_el = new dt_ui_element(element_name + "_lbl_preset_el");
	this.button_el_0 = new dt_ui_button(element_name + "_el_0");
	this.button_el_30 = new dt_ui_button(element_name + "_el_30");
	this.button_el_90 = new dt_ui_button(element_name + "_el_90");

	this.preset_el = new dt_ui_element(element_name + "_preset_el");

	this.lbl_preset_azel = new dt_ui_element(element_name + "_lbl_preset_azel");
	this.button_azel_focus = new dt_ui_button(element_name + "_azel_focus");
	this.button_azel_show = new dt_ui_button(element_name + "_azel_show");

	this.preset_azel = new dt_ui_element(element_name + "_preset_azel");

	this.window.add(
	    [this.position_elem, this.action_elem, 
	     this.preset_az, this.preset_el, this.preset_azel]);

	this.position_elem.add([this.pos_v1, this.pos_v2, this.pos_v3]);
	this.pos_v1.add(
	    [this.lbl_filler, this.lbl_last_setpoint, this.lbl_new_setpoint]);
	this.pos_v2.add(
	    [this.lbl_azimuth, this.val_last_azimuth, this.txt_new_azimuth]);
	this.pos_v3.add(
	    [this.lbl_elevation, this.val_last_elevation, this.txt_new_elevation]);

	this.action_elem.add(
	    [this.button_track, this.button_copy_pos, this.button_copy_last]);

	this.preset_az.add(
	    [this.lbl_preset_az,
	     this.button_az_n270, this.button_az_n180, this.button_az_n90,
	     this.button_az_0,
	     this.button_az_p90, this.button_az_p180, this.button_az_p270]);

	this.preset_el.add(
	    [this.lbl_preset_el,
	     this.button_el_0, this.button_el_30, this.button_el_90]);

	this.preset_azel.add(
	    [this.lbl_preset_azel,
	     this.button_azel_focus, this.button_azel_show]);
	
	this.lbl_azimuth.wrap_set(false);
	this.lbl_azimuth.text_set("Azimuth");
	this.lbl_elevation.wrap_set(false);
	this.lbl_elevation.text_set("Elevation");
	this.lbl_last_setpoint.wrap_set(false);
	this.lbl_last_setpoint.text_set("Last Setpoint:");
	this.lbl_new_setpoint.wrap_set(false);
	this.lbl_new_setpoint.text_set("New Setpoint:");

	this.val_last_azimuth.value_set("-----");
	this.val_last_elevation.value_set("-----");
	this.txt_new_azimuth.length_set(9);
	this.txt_new_elevation.length_set(9);

	this.button_track.text_set("Track new setpoint");
	this.button_copy_pos.text_set("Copy current position");
	this.button_copy_last.text_set("Copy last setpoint");
	
	this.lbl_preset_az.text_set("Azimuth:");
	this.button_az_n270.text_set("W -270");
	this.button_az_n180.text_set("N -180");
	this.button_az_n90.text_set("E -90");
	this.button_az_0.text_set("S 0");
	this.button_az_p90.text_set("W 90");
	this.button_az_p180.text_set("N 180");
	this.button_az_p270.text_set("E 270");

	this.lbl_preset_el.text_set("Elevation:");
	this.button_el_0.text_set("Horizon 0");
	this.button_el_30.text_set("Show 30");
	this.button_el_90.text_set("Zenith 90");
	
	this.lbl_preset_azel.wrap_set(false);
	this.lbl_preset_azel.text_set("Azimuth & Elevation:");
	this.button_azel_focus.text_set("Focusbox 134.7, -0.05");
	this.button_azel_show.text_set("Show 30, 30");

	this.position_elem.resize_equal(
	    [this.lbl_filler,
	     this.lbl_azimuth, this.lbl_elevation,
	     this.lbl_last_setpoint, this.lbl_new_setpoint,
	     this.val_last_azimuth, this.val_last_elevation,
	     this.txt_new_azimuth, this.txt_new_elevation]);
	this.pos_v1.align_vertical(
	    [this.lbl_filler, this.lbl_last_setpoint, this.lbl_new_setpoint], 5);
	this.pos_v2.align_vertical(
	    [this.lbl_azimuth, this.val_last_azimuth, this.txt_new_azimuth], 5);
	this.pos_v3.align_vertical(
	    [this.lbl_elevation, this.val_last_elevation, this.txt_new_elevation], 5);
	this.position_elem.align_horizontal(
	    [this.pos_v1, this.pos_v2, this.pos_v3], 5);

	this.action_elem.align_vertical(
	    [this.button_track, this.button_copy_pos], 10);
	this.action_elem.align_horizontal(
	    [this.button_copy_pos, this.button_copy_last], 10);

	this.window.align_vertical(
	    [this.position_elem, this.action_elem], 5);

	this.preset_az.resize_equal(
	    [this.lbl_preset_az,
	     this.button_az_n270, this.button_az_n180, this.button_az_n90,
	     this.button_az_0,
	     this.button_az_p90, this.button_az_p180, this.button_az_p270]);
	this.preset_az.align_vertical(
	    [this.lbl_preset_az,
	     this.button_az_n270, this.button_az_n180, this.button_az_n90,
	     this.button_az_0,
	     this.button_az_p90, this.button_az_p180, this.button_az_p270]);

	this.preset_el.resize_equal(
	    [this.lbl_preset_el,
	     this.button_el_0, this.button_el_30, this.button_el_90]);
	this.preset_el.align_vertical(
	    [this.lbl_preset_el,
	     this.button_el_0, this.button_el_30, this.button_el_90]);

	this.preset_azel.resize_equal(
	    [this.lbl_preset_azel,
	     this.button_azel_focus, this.button_azel_show]);
	this.preset_azel.align_vertical(
	    [this.lbl_preset_azel,
	     this.button_azel_focus, this.button_azel_show]);


	this.window.align_horizontal(
	    [this.position_elem, 
	     this.preset_az, this.preset_el, this.preset_azel], 10);
	
	/*
	
		block behaviour.
	
	 */
	
	this.do_track = function()
	{
		var az = azel_this.txt_new_azimuth.value_get();
		var el = azel_this.txt_new_elevation.value_get();
		
		az = floatval(az);
		el = floatval(el);
		
		azel_this.txt_new_azimuth.value_set(az);
		azel_this.txt_new_elevation.value_set(el);
		
		if (az > 270 || az < -270 || el > 91 || el < -1) {
			alert("("+ az + "," + el + ") is not a vlid position.");
		} else {
			dt_websocket_send("command azel " +
			    az + " " + el);
		
			azel_this.val_last_azimuth.value_set(az);
			azel_this.val_last_elevation.value_set(el);
		}
	}
	
	this.set_az = function(az)
	{
		this.txt_new_azimuth.value_set(az);
	}

	this.set_el = function(el)
	{
		this.txt_new_elevation.value_set(el);
	}

	this.button_track.onclick = function() { azel_this.do_track() }

	this.button_copy_last.onclick = function() {
		azel_this.set_el(azel_this.val_last_elevation.value_get());
		azel_this.set_az(azel_this.val_last_azimuth.value_get());
	}

	this.azimuth_position_get = function() { return 0; }
	this.elevation_position_get = function() { return 0; }

	this.copy_position = function() 
	{
		azel_this.set_el(azel_this.elevation_position_get());
		azel_this.set_az(azel_this.azimuth_position_get());
	}

	this.button_copy_pos.onclick = function() { azel_this.copy_position() }

	this.button_az_n270.onclick = function() { azel_this.set_az(-270) }
	this.button_az_n180.onclick = function() { azel_this.set_az(-180) }
	this.button_az_n90.onclick = function() { azel_this.set_az(-90) }
	this.button_az_0.onclick = function() { azel_this.set_az(0) }
	this.button_az_p90.onclick = function() { azel_this.set_az(90) }
	this.button_az_p180.onclick = function() { azel_this.set_az(180) }
	this.button_az_p270.onclick = function() { azel_this.set_az(270) }

	this.button_el_0.onclick = function() { azel_this.set_el(0) }
	this.button_el_30.onclick = function() { azel_this.set_el(30) }
	this.button_el_90.onclick = function() { azel_this.set_el(90) }

	this.button_azel_focus.onclick = function() { 
		azel_this.set_el(-0.05);
		azel_this.set_az(134.7)
	}
	this.button_azel_show.onclick = function() { 
		azel_this.set_el(30);
		azel_this.set_az(30)
	}

	/*
	
		The complete 'azel' block can be switched on and off.
	
	 */

	this.visible = true;
	this.visible_set = function(visible)
	{
		if (azel_this.visible != visible && visible) {
			azel_this.copy_position();
		}
		azel_this.visible = visible;
		azel_this.window.visible_set(visible);
	}

}

} /* azel_loaded */
