/*
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2009
	Copyright Stichting C.A. Muller Radioastronomiestation, 2009

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

var dt_view_loaded;
if (!dt_view_loaded) {
dt_view_loaded = true;

function azimuth_view(element)
{
	var a_v_this = this;

	this.canvas = document.getElementById(element);
        this.ctx = this.canvas.getContext("2d");
        
	this.ctx.scale(
	    this.canvas.width / 100,
	    this.canvas.height / 100);

	this.ctx.translate(50,50);

        this.az = -1;
        this.az_should = -1;
        
        this.draw = function azimuth_view_draw(az_val)
        {
        	if (az_val != a_v_this.az) {
                	a_v_this.az = az_val;
                
			a_v_this.ctx.save();
			
			a_v_this.draw_dt(az_val);
			
			a_v_this.ctx.restore();
                }
	}
	
	this.draw_err = function azimuth_view_draw_err(az_val, az_should)
	{
        	if (az_val != a_v_this.el || az_should != a_v_this.az_should) {
                	a_v_this.az = az_val;
                	a_v_this.az_should = az_should;
                
			a_v_this.ctx.save();
			
			a_v_this.draw_dt(az_val);
			
			a_v_this.ctx.restore();
			a_v_this.ctx.save();

	                a_v_this.ctx.rotate(az_should - Math.PI/2);

	                a_v_this.ctx.fillStyle = "rgba(255, 0, 0, 0.5)";
/*	                a_v_this.ctx.strokeStyle = "rgb(255, 0, 0)";
			a_v_this.ctx.beginPath();
			a_v_this.ctx.moveTo(0,0);
			a_v_this.ctx.lineTo(0, 5);
			a_v_this.ctx.lineTo(-45, 0);
			a_v_this.ctx.lineTo(0, -5);
			a_v_this.ctx.lineTo(0, 0);
			a_v_this.ctx.fill();
			a_v_this.ctx.stroke();
*/
			a_v_this.ctx.beginPath();
			a_v_this.ctx.strokeStyle = "rgba(255, 0, 0, 0.5)";
			a_v_this.ctx.moveTo(0,0);
			a_v_this.ctx.lineTo(-50, 0);
			if (az_val > az_should)
				a_v_this.ctx.arc(0, 0,
				    50, 
				    Math.PI, Math.PI + az_val - az_should,
				    false);
			else if (az_val < az_should)
				a_v_this.ctx.arc(0, 0,
				    50,
				    Math.PI, Math.PI + az_val - az_should,
				    true);
			a_v_this.ctx.lineTo(0, 0);
			a_v_this.ctx.fill();
			a_v_this.ctx.stroke();

			a_v_this.ctx.restore();
                }
	}
	
	this.draw_dt = function azimuth_view_draw_dt(az_val)
	{
                a_v_this.ctx.fillStyle = "rgb(255, 255, 255)";
                a_v_this.ctx.fillRect(-50, -50, 100, 100);

		a_v_this.ctx.strokeStyle = "rgb(0, 0, 128)";
		//N
		a_v_this.ctx.beginPath();
		a_v_this.ctx.moveTo(-4, -40);
		a_v_this.ctx.lineTo(-4, -50);
		a_v_this.ctx.lineTo( 4, -40);
		a_v_this.ctx.lineTo( 4, -50);
		a_v_this.ctx.stroke();
		//W
		a_v_this.ctx.beginPath();
		a_v_this.ctx.moveTo(-50, -5);
		a_v_this.ctx.lineTo(-47.5, 5);
		a_v_this.ctx.lineTo(-45, -3);
		a_v_this.ctx.lineTo(-42.5, 5);
		a_v_this.ctx.lineTo(-40, -5);
		a_v_this.ctx.stroke();
		//E
		a_v_this.ctx.beginPath();
		a_v_this.ctx.moveTo( 50, -5);
		a_v_this.ctx.lineTo( 42, -5);
		a_v_this.ctx.lineTo( 42, 0);
		a_v_this.ctx.lineTo( 47, 0);
		a_v_this.ctx.moveTo( 42, 0);
		a_v_this.ctx.lineTo( 42, 5);
		a_v_this.ctx.lineTo( 50, 5);
		a_v_this.ctx.stroke();
		//S
		a_v_this.ctx.beginPath();
		a_v_this.ctx.arc(0,42.5, 2.5, 0, 0.7*Math.PI, true);
		a_v_this.ctx.arc(0,47.5, 2.5, -0.3*Math.PI, Math.PI, false);
		a_v_this.ctx.stroke();

		a_v_this.ctx.rotate(az_val);

                a_v_this.ctx.fillStyle = "rgb(128, 128, 128)";
		a_v_this.ctx.beginPath();
		a_v_this.ctx.moveTo(-30, 5);
		a_v_this.ctx.lineTo( 30, 5);
		a_v_this.ctx.lineTo( 30,-25);
		a_v_this.ctx.lineTo(-30,-25);
		a_v_this.ctx.lineTo(-30, 5);
		a_v_this.ctx.fill();
		
		a_v_this.ctx.beginPath();
                a_v_this.ctx.strokeStyle = "rgb(128, 128, 255)";
		a_v_this.ctx.moveTo(0, 0);
		a_v_this.ctx.lineTo(20, 0);
		a_v_this.ctx.lineTo(0, 40);
		a_v_this.ctx.lineTo(-20, 0);
		a_v_this.ctx.lineTo(0, 0);
                a_v_this.ctx.stroke();

		a_v_this.ctx.beginPath();
                a_v_this.ctx.fillStyle = "rgb(128, 128, 255)";
                a_v_this.ctx.strokeStyle = "rgb(0, 0, 255)";
                a_v_this.ctx.moveTo(0,0);
		a_v_this.ctx.lineTo(-20, 0);
		a_v_this.ctx.lineTo(-40, 20);
		a_v_this.ctx.lineTo(40, 20);
		a_v_this.ctx.lineTo(20, 0);
		a_v_this.ctx.lineTo(0, 0);
                a_v_this.ctx.fill();
		a_v_this.ctx.stroke();
        }
}

function elevation_view(element)
{
	var e_v_this = this;

	this.canvas = document.getElementById(element);
        this.ctx = this.canvas.getContext("2d");
        
	this.ctx.scale(
	    this.canvas.width / 100,
	    this.canvas.height / 100);

	this.ctx.translate(50,50);

        this.el = -1;
        this.el_should = -1;
        
        this.draw = function elevation_view_draw(el_val)
        {
        	if (el_val != e_v_this.el) {
                	e_v_this.el = el_val;
                
			e_v_this.ctx.save();
			
			e_v_this.draw_dt(el_val);
			
			e_v_this.ctx.restore();
                }
	}
	
	this.draw_err = function elevation_view_draw_err(el_val, el_should)
	{
        	if (el_val != e_v_this.el || el_should != e_v_this.el_should) {
                	e_v_this.el = el_val;
                	e_v_this.el_should = el_should;
                
			e_v_this.ctx.save();
			
			e_v_this.draw_dt(el_val);
			
			e_v_this.ctx.restore();
			e_v_this.ctx.save();

	                e_v_this.ctx.rotate(el_should);

	                e_v_this.ctx.fillStyle = "rgba(255, 0, 0, 0.5)";
/*	                e_v_this.ctx.strokeStyle = "rgb(255, 0, 0)";
			e_v_this.ctx.beginPath();
			e_v_this.ctx.moveTo(0,0);
			e_v_this.ctx.lineTo(0, 5);
			e_v_this.ctx.lineTo(-45, 0);
			e_v_this.ctx.lineTo(0, -5);
			e_v_this.ctx.lineTo(0, 0);
			e_v_this.ctx.fill();
			e_v_this.ctx.stroke();
*/
			e_v_this.ctx.beginPath();
			e_v_this.ctx.strokeStyle = "rgba(255, 0, 0, 0.5)";
			e_v_this.ctx.moveTo(0,0);
			e_v_this.ctx.lineTo(-50, 0);
			if (el_val > el_should)
				e_v_this.ctx.arc(0, 0,
				    50, 
				    Math.PI, Math.PI + el_val - el_should,
				    false);
			else if (el_val < el_should)
				e_v_this.ctx.arc(0, 0,
				    50,
				    Math.PI, Math.PI + el_val - el_should,
				    true);
			e_v_this.ctx.lineTo(0, 0);
			e_v_this.ctx.fill();
			e_v_this.ctx.stroke();

			e_v_this.ctx.restore();
                }
	}
	
	this.draw_dt = function elevation_view_draw_dt(el_val)
	{
                e_v_this.ctx.fillStyle = "rgb(255, 255, 255)";
                e_v_this.ctx.fillRect(-50, -50, 100, 100);

                e_v_this.ctx.fillStyle = "rgb(128, 128, 128)";
		e_v_this.ctx.beginPath();
		e_v_this.ctx.moveTo(0,0);
		e_v_this.ctx.lineTo(25, 20);
		e_v_this.ctx.lineTo(25, 40);
		e_v_this.ctx.lineTo(-5, 40);
		e_v_this.ctx.lineTo(5, 20);
		e_v_this.ctx.lineTo(0, 0);
		e_v_this.ctx.fill();
			
                e_v_this.ctx.rotate(el_val + Math.PI/2);
                        
		e_v_this.ctx.beginPath();
                e_v_this.ctx.strokeStyle = "rgb(128, 128, 255)";
		e_v_this.ctx.moveTo(0, 0);
		e_v_this.ctx.lineTo(20, 0);
		e_v_this.ctx.lineTo(0, 40);
		e_v_this.ctx.lineTo(-20, 0);
		e_v_this.ctx.lineTo(0, 0);
                e_v_this.ctx.stroke();

		e_v_this.ctx.beginPath();
                e_v_this.ctx.fillStyle = "rgb(128, 128, 255)";
                e_v_this.ctx.strokeStyle = "rgb(0, 0, 255)";
                e_v_this.ctx.moveTo(0,0);
		e_v_this.ctx.lineTo(-20, 0);
		e_v_this.ctx.lineTo(-40, 20);
		e_v_this.ctx.lineTo(40, 20);
		e_v_this.ctx.lineTo(20, 0);
		e_v_this.ctx.lineTo(0, 0);
                e_v_this.ctx.fill();
		e_v_this.ctx.stroke();
        }
}

function satellite_view(element)
{
	var s_v_this = this;

	this.canvas = document.getElementById(element);

        this.ctx = this.canvas.getContext("2d");
        
	this.ctx.scale(
	    this.canvas.width / 100,
	    this.canvas.height / 100);

	this.ctx.translate(50,50);

	this.coord2xy = function satellite_view_coord2xy(coord) {
		var az = coord.az * Math.PI / 180;
		var el = 50 - (coord.el/90 * 50);
		
		var x = Math.sin(-az) * el;
		var y = Math.cos(-az) * el;
		
//		alert(coord.az + " " + coord.el + " " + az +" "+ el  +" "+ x +" "+ y);
		
		return (new function() {
			this.x = x;
			this.y = y;
		});
	}

        this.draw = function satellite_view_draw(coords)
        {
		var i;
		var coord;
		
		s_v_this.ctx.save();

		/* white */
                s_v_this.ctx.fillStyle = "rgb(255, 255, 255)";
                s_v_this.ctx.fillRect(-50, -50, 100, 100);

		/* background */
		s_v_this.ctx.strokeStyle = "rgba(0, 0, 0, 0.25)";
		s_v_this.ctx.beginPath();
		s_v_this.ctx.arc(0, 0, 50, 0, 2 * Math.PI);
		s_v_this.ctx.lineTo(-50,0);
		s_v_this.ctx.moveTo(0,50);
		s_v_this.ctx.lineTo(0,-50);
		s_v_this.ctx.stroke();
		s_v_this.ctx.beginPath();
		s_v_this.ctx.arc(0, 0, 16.7, 0, 2 * Math.PI);
		s_v_this.ctx.stroke();
		s_v_this.ctx.beginPath();
		s_v_this.ctx.arc(0, 0, 33.3, 0, 2 * Math.PI);
		s_v_this.ctx.stroke();


		s_v_this.ctx.strokeStyle = "rgb(0, 0, 255)";
		//N
		s_v_this.ctx.beginPath();
		s_v_this.ctx.moveTo(-4, -40);
		s_v_this.ctx.lineTo(-4, -50);
		s_v_this.ctx.lineTo( 4, -40);
		s_v_this.ctx.lineTo( 4, -50);
		s_v_this.ctx.stroke();
		//W
		s_v_this.ctx.beginPath();
		s_v_this.ctx.moveTo(-50, -5);
		s_v_this.ctx.lineTo(-47.5, 5);
		s_v_this.ctx.lineTo(-45, -3);
		s_v_this.ctx.lineTo(-42.5, 5);
		s_v_this.ctx.lineTo(-40, -5);
		s_v_this.ctx.stroke();
		//E
		s_v_this.ctx.beginPath();
		s_v_this.ctx.moveTo( 50, -5);
		s_v_this.ctx.lineTo( 42, -5);
		s_v_this.ctx.lineTo( 42, 0);
		s_v_this.ctx.lineTo( 47, 0);
		s_v_this.ctx.moveTo( 42, 0);
		s_v_this.ctx.lineTo( 42, 5);
		s_v_this.ctx.lineTo( 50, 5);
		s_v_this.ctx.stroke();
		//S
		s_v_this.ctx.beginPath();
		s_v_this.ctx.arc(0,42.5, 2.5, 0, 0.7*Math.PI, true);
		s_v_this.ctx.arc(0,47.5, 2.5, -0.3*Math.PI, Math.PI, false);
		s_v_this.ctx.stroke();


		if (coords == null)
			return;

		/* satellite line */
		
                s_v_this.ctx.strokeStyle = "rgb(255, 0, 0)";
		s_v_this.ctx.beginPath();
		
		coord = this.coord2xy(coords[0]);
		s_v_this.ctx.moveTo(coord.x, coord.y);
//		alert("x " + coord.x + " y " + coord.y);

		for (i = 1; i < coords.length; i++) {
			coord = this.coord2xy(coords[i]);
			s_v_this.ctx.lineTo(coord.x, coord.y);
		}

		s_v_this.ctx.stroke();

		s_v_this.ctx.restore();
	}
	
}


} /* dt_view_loaded */
