/* 
	Javascript for websocket communication

	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

var dt_websocket_loaded;
if (!dt_websocket_loaded) {
dt_websocket_loaded = true;

var dt_socket;
var dt_socket_url;
var dt_socket_open;

var dt_socket_onopen = new Array();
var dt_socket_onmessage = new Array();

function dt_websocket(url)
{
	if (dt_socket) {
		return;
	}
	
	dt_socket_url = url;
	dt_socket = this;
	this.ws = new WebSocket(url);
	
	this.ws.onopen = function()
	{
		var i;

		for (i = 0; i < dt_socket_onopen.length; i++) {
			dt_socket_onopen[i].func(dt_socket_onopen[i].obj);
		}
		dt_socket_open = true;
	}

	this.ws.onclose = function(){
		//try to reconnect in 3 seconds
		setTimeout(function(){dt_socket = new dt_websocket(dt_socket_url)}, 3000);
	}

	this.ws.onmessage = function(msg)
	{
		var args = msg.data.split(" ");
		var i;
		
		for (i = 0; i < dt_socket_onmessage.length; i++) {
			if(dt_socket_onmessage[i].name == args[0]) {
				dt_socket_onmessage[i].func(
				    dt_socket_onmessage[i].obj,
				    args);
				return;
			}
		}
		alert("no handler for: " + msg.data);
	}
}

function dt_websocket_send(msg)
{
	dt_socket.ws.send(msg);
}

function dt_websocket_onopen_add(name, func, obj)
{
	for (i = 0; i < dt_socket_onopen.length; i++) {
		if (dt_socket_onopen[i].name == name) {
			dt_socket_onopen[i].func = func;
			dt_socket_onopen[i].obj = obj;
			return;
		}
	}
	dt_socket_onopen[dt_socket_onopen.length] = new function() {
		this.name = name;
		this.func = func;
		this.obj = obj;
	}
	
	if (dt_socket_open)
		func(obj);
}

function dt_websocket_onmessage_add(name, func, obj)
{
	for (i = 0; i < dt_socket_onmessage.length; i++) {
		if (dt_socket_onmessage[i].name == name) {
			dt_socket_onmessage[i].func = func;
			dt_socket_onmessage[i].obj = obj;
			return;
		}
	}
	dt_socket_onmessage[dt_socket_onmessage.length] = new function() {
		this.name = name;
		this.func = func;
		this.obj = obj;
	}
}

} /* dt_websocket loaded */
