/* 
	Javascript sending sun tracker commands 

	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2014
	Copyright Stichting C.A. Muller Radioastronomiestation, 2014

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */


var sun_loaded;
if (!sun_loaded) {
sun_loaded = true;

eval(load("dt_ui.js"));
eval(load("utils.js"));
eval(load("status.js"));

var sun_status_url = "status.cgi";
var sun_command_url = "command.cgi_sun";


function sun(element_name) {
	var sun_this = this;

	/* 

		Create all the UI elements

	 */

	this.window = new dt_ui_window(element_name);
	
	this.window.title_set("Sun tracker");

	this.button_enabled = new dt_ui_button_indicator(element_name + "_enabled");
	this.button_dt_model_enabled = new dt_ui_button_indicator(element_name + "_dt_model_enabled");

	this.window.add(
	    [this.button_enabled, this.button_dt_model_enabled]);

	this.button_enabled.text_set("Tracking enabled");
	this.button_dt_model_enabled.text_set("DT model");
	
	this.window.align_horizontal(
	    [this.button_enabled, this.button_dt_model_enabled], 10);
	
	/*
	
		block behaviour.
	
	 */
	
	this.pairlist_prev = "??";
	this.enabled = false;
	this.dt_model_enabled = false;

	this.status = new status(sun_status_url, "sun");
	this.status.callback_keyvalue = function(pairlist)
	{
		if (!array_compare(pairlist, sun_this.pairlist_prev)) {
			var i;

			sun_this.pairlist_prev = pairlist;

			for (i = 0; i < pairlist.length; i++) {
				var boolvalue;
				
				if (pairlist[i][1].charAt(0) == '0') {
					boolvalue = false;
				} else {
					boolvalue = true;
				}

				if (pairlist[i][0] == 'dt_model') {
					sun_this.button_dt_model_enabled.color_set(
					    boolvalue ?
					    dt_ui_color_indicator_green :
					    dt_ui_color_indicator_red);
					sun_this.dt_model_enabled = boolvalue;
				} else if (pairlist[i][0] == 'enabled') {
					sun_this.button_enabled.color_set(
					    boolvalue ?
					    dt_ui_color_indicator_green :
					    dt_ui_color_indicator_red);
					sun_this.enabled = boolvalue;
				}
			}
		}
	}
	this.status.open();


	this.command = new command(sun_command_url, "sun");
	
	this.button_enabled.onclick = function(elem) {
		sun_this.command.send("enabled=" + (sun_this.enabled ? "0" : "1"));
	}

	this.button_dt_model_enabled.onclick = function(elem) {
		sun_this.command.send("dt_model=" + (sun_this.dt_model_enabled ? "0" : "1"));
	}

	/*
	
		The complete 'sun' block can be switched on and off.
	
	 */


	this.visible_set = function(visible)
	{
		sun_this.window.visible_set(visible);
		if (!visible) {
			sun_this.command.send("enabled=0");
		}
	}

}

} /* sun_loaded */
