/* 
	Javascript for parsing traces over XMLHttp 

	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2008
	Copyright Stichting C.A. Muller Radioastronomiestation, 2008

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

function trace_list_entry (tracename, unit)
{
	this.tracename = tracename;
	this.unit = unit;
}

function trace_list ()
{
	var trace_this = this;

	/* Callbacks */
	this.callback = trace_cb_default;

	this.list = new Array();

	this.handle_xml = function (event)
	{
		var lines = event.target.responseText.split("\n");
		
		for (i = 0; i < lines.length - 1; i++) {
			trace_this.list[i] = new trace_list_entry(
			    lines[i].split("\t")[0],
			    lines[i].split("\t")[1]
			);
		}
		
	}

	this.open = function (url)
	{
		var xrequest = new XMLHttpRequest();
	
		xrequest.multipart = false;
		xrequest.open("GET", url, false);
		xrequest.onload = this.handle_xml;
		xrequest.send(null);
	}
}

