/*
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2009
	Copyright Stichting C.A. Muller Radioastronomiestation, 2009

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

var utils_loaded;
if (!utils_loaded) {
utils_loaded = true;

var utils_rad2deg_const = 180/Math.PI;

function rad2deg(rad)
{
	return rad * utils_rad2deg_const;
}

var utils_deg2rad_const = Math.PI/180.0;

function deg2rad(deg)
{
	return deg * utils_deg2rad_const;
}

function decimals(val, decimals)
{
	fact = Math.pow(10, decimals);
	return Math.round(fact*val)/fact;
}

var utils_rads2rpm_const = 60.0/(Math.PI*2)

function rads2rpm(rads)
{
	return rads * utils_rads2rpm_const;
}

function floatval(val)
{
	var i;
	var newval = "";
	var dotfound = 0;
	var numberafterdot;
	var digitfound = 0;
	
	if (val==null)
		return null;
	
	for (i = 0; i < val.length; i++)
	{
		switch (val.charAt(i)) {
			case ',':
			case '.':
				if (!dotfound) {
					dotfound = 1;
					digitfound = 0;
					newval += '.';
				}
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
				newval += val.charAt(i);
				digitfound = 1;
				break;
			case '-':
				if (newval.length == 0) {
					newval = "-";
				}
				break;
			default:
				break;
		}
	}
	if (!digitfound && !dotfound) {
		newval = "0";
	}
	if (!dotfound) {
		newval += ".";
		digitfound = 0;
	}
	if (!digitfound) {
		newval += "0";
	}
	
	return newval;
}

function array_compare(a1, a2)
{
	var i;
	
	if (!a1)
		return false;
	if (!a2)
		return false;
	
	if (a1.length != a2.length)
		return false;
	
	for (i = 0; i < a1.length; i++) {
		if (a1[i] instanceof Array && a2[i] instanceof Array) {
			if (!array_compare(a1[i], a2[i]))
				return false;
		} else {
			if (a1[i] != a2[i])
				return false;
		}
	}
	
	return true;
}

} /*utils_loaded */
