/*
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2007
	Copyright Stichting C.A. Muller Radioastronomiestation, 2007

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <controller/controller_block.h>

/*
  	 outputs
  	 nr name

  -----------------
  |		  |
  |	 0  value |----
  |		  |
  -----------------

 */

struct controller_block_private {
	float value;
};

static void random_calculate(struct controller_block *random)
{
	random->private->value = ((float)rand() / (RAND_MAX / 2)) - 1.0;
}

static struct controller_block_outterm_list outterms[] = {
	{ "value", CONTROLLER_BLOCK_TERM_FLOAT, offsetof(struct controller_block_private, value) },
	{ NULL }
};

struct controller_block * block_random_create(char *name)
{
	struct controller_block *random;
	
	if (!(random = controller_block_alloc("random", name, sizeof(struct controller_block_private))))
		return NULL;

	random->private->value = 0.0;
	
	if (controller_block_outterm_list_init(random, outterms))
		goto err_block;

	random->calculate = random_calculate;

	random->params = 0;
	random->param = NULL;

	controller_block_add(random);
	return random;

err_block:
	controller_block_free(random);
	return NULL;
}
