#ifndef _INCLUDE_IL2C_H_
#define _INCLUDE_IL2C_H_

#include <stdbool.h>

void yyerror(char const *s);

enum {
	IL2C_VAR_NONE,
	IL2C_VAR,
	IL2C_VAR_CONFIG,
	IL2C_VAR_INPUT,
	IL2C_VAR_OUTPUT
};

void il2c_program(char *program);

void il2c_var_category(int cat);

void il2c_var_add(int type, char *name, int initsym, char *initval);
void il2c_sample_header(void);
void il2c_sample_footer(void);

void il2c_literal_type_set(int);
int il2c_literal_type_get(void);

void il2c_var_declare(void);


void il2c_op_start(void);
void il2c_op_usevar(char *name);
void il2c_op_literal(char *val, int type);
void il2c_op_token(char *tok);
void il2c_op_token_sym(int sym);
void il2c_op_result(int type);
void il2c_sel(char *varfalse, char *vartrue, int type);
void il2c_op_end(void);

void il2c_op_stack_push(void);
void il2c_op_stack_pop(void);
void il2c_op_acc_use(void);

void il2c_store(char *name, bool negate);
void il2c_load(char *name, bool negate);

void il2c_load_literal(char *name, int type, bool negate);

void il2c_set(char *name, bool setcond);

void il2c_label(char *name);
void il2c_jump(char *name);
void il2c_jumpcond(char *name, bool negate);

void il2c_converttype(int from, int to);

void il2c_abs(void);
void il2c_mathfunc(char *func);
void il2c_expt(char *exp);

void il2c_shift(char *shift, char *val);
void il2c_rotate(char *val, bool left);
void il2c_not(void);

void il2c_minmax(bool max, char *val);

char *il2c_system_time(void);
int il2c_system_time_type(void);

#endif /* _INCLUDE_IL2C_H_ */
