
EC_TARGETS += $(LIBDIR)/libethercat.la


EC_SRCS = \
	$(DIR)/ec.c \
	$(DIR)/esc.c \
	$(DIR)/esc_coe.c \
	$(DIR)/esc_esi.c \
	$(DIR)/esc_mailbox.c \
	$(DIR)/esc_device.c \
	$(DIR)/esc_watchdog.c \
	$(DIR)/esc_dc.c \
	$(DIR)/canopen.c \
	$(DIR)/ec_stoeber.c \
	$(DIR)/block_ec.c \
	$(DIR)/block_beckhoff_el1xxx.c \
	$(DIR)/block_beckhoff_el2xxx.c \
	$(DIR)/block_beckhoff_el2502.c \
	$(DIR)/block_beckhoff_el3xxx.c \
	$(DIR)/block_beckhoff_el4xxx.c \
	$(DIR)/block_beckhoff_el5001.c \
	$(DIR)/block_beckhoff_el5101.c \
	$(DIR)/block_beckhoff_el7031.c \
	$(DIR)/block_stoeber.c

ifeq ($(OS), FreeBSD)
	EC_SRCS+= $(DIR)/eth_bsd.c
else
	EC_SRCS+= $(DIR)/eth_linux.c
endif

EC_OBJS := $(EC_SRCS:.c=.lo)


$(EC_OBJS): CFLAGS += -O3 -Wall
$(LIBDIR)/libethercat.la: libcontroller.la liblog.la
$(LIBDIR)/libethercat.la_LDFLAGS += -lm -lpthread -lcontroller -llog
$(LIBDIR)/libethercat.la: $(EC_OBJS)
	$(LIB_LINK)


EC_TARGETS += $(DIR)/ec_enum

EC_ENUM_SRCS = $(DIR)/ec_enum.c
EC_ENUM_OBJS := $(EC_ENUM_SRCS:.c=.o)

$(EC_ENUM_SRCS): CFLAGS += -O3 -Wall
$(DIR)/ec_enum: libethercat.la
$(DIR)/ec_enum_LDFLAGS += -lethercat
$(DIR)/ec_enum: $(EC_ENUM_OBJS)

TARGETS += $(EC_TARGETS)
CLEAN += $(EC_TARGETS) $(EC_OBJS) $(EC_ENUM_OBJS)
SRCS += $(EC_SRCS) $(EC_ENUM_SRCS)
