/*
	Copyright Jeroen Vreeken (pe1rxq@amsat.org), 2013
	Copyright Stichting C.A. Muller Radioastronomiestation, 2013

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef _INCLUDE_EC_ESC_DEVICE_H_
#define _INCLUDE_EC_ESC_DEVICE_H_

#include <stdbool.h>

#include <ec/ec.h>
#include <ec/esc.h>
#include <ec/esc_sm.h>
#include <ec/esc_dc.h>

struct esc_device {
	struct ec_dgram_addr addr;
	
	struct esc_esi_category *categories;
	
	struct esc_syncmanager_info sm[ESC_SYNCMANAGER_MAX];
	bool rx_pdo;
	bool tx_pdo;
	int rx_pdo_sm;
	int tx_pdo_sm;
	bool tx_pdo_watchdog;
	int mbox_rd_sm;
	int mbox_wr_sm;
	
	unsigned char *tx_data;
	unsigned char *rx_data;
	
	struct esc_mailbox *mailbox;
	struct esc_dc_sync dc_sync;

	char *name;
	
	enum esc_al_state state;
	enum esc_al_status status;
	
	bool auto_recover;
};


struct esc_device *esc_device_create(struct ec_dgram_addr *ec_addr, char *name);
void esc_device_destroy(struct esc_device *);
int esc_device_poll_start(struct esc_device *dev);

int esc_device_initialize_pre_operational(struct esc_device *dev);

#endif /* _INCLUDE_EC_ESC_DEVICE_H_ */
